<?php

namespace Drupal\formassembly;

use Drupal\Core\Entity\EntityAccessControlHandler;
use Drupal\Core\Entity\EntityInterface;
use Drupal\Core\Session\AccountInterface;
use Drupal\Core\Access\AccessResult;

/**
 * Access controller for the FormAssembly Form entity.
 *
 * @see \Drupal\formassembly\Entity\FormAssemblyEntity.
 */
class FormAssemblyEntityAccessControlHandler extends EntityAccessControlHandler {

  /**
   * {@inheritdoc}
   */
  protected function checkAccess(EntityInterface $entity, $operation, AccountInterface $account) {
    /** @var \Drupal\formassembly\Entity\FormAssemblyEntityInterface $entity */
    switch ($operation) {
      case 'view':
        return AccessResult::allowedIfHasPermission($account, 'view formassembly form entities');

      case 'update':
        return AccessResult::allowedIfHasPermission($account, 'edit formassembly form entities');

      case 'delete':
        return AccessResult::allowedIfHasPermission($account, 'delete formassembly form entities');
    }

    // Unknown operation, no opinion.
    return AccessResult::neutral();
  }

  /**
   * {@inheritdoc}
   */
  protected function checkCreateAccess(AccountInterface $account, array $context, $entity_bundle = NULL) {
    return AccessResult::allowedIfHasPermission($account, 'add formassembly form entities');
  }

}
